All of lore.kernel.org
 help / color / mirror / Atom feed
From: Luis Chamberlain <mcgrof@kernel.org>
To: shinichiro.kawasaki@wdc.com
Cc: linux-block@vger.kernel.org, hare@suse.de,
	patches@lists.linux.dev, gost.dev@samsung.com, mcgrof@kernel.org
Subject: [PATCH blktests v3 5/6] tests: use test device min io to support bs > ps
Date: Wed, 12 Feb 2025 12:54:47 -0800	[thread overview]
Message-ID: <20250212205448.2107005-6-mcgrof@kernel.org> (raw)
In-Reply-To: <20250212205448.2107005-1-mcgrof@kernel.org>

When a block device supports a minimum block size > ps we must
ensure we don't issue IOs below what is supported. Just leverage
the min optimal IO to also ensure we use the optimal IO as well.

Signed-off-by: Luis Chamberlain <mcgrof@kernel.org>
---
 tests/block/003 |  6 +++++-
 tests/block/007 |  5 ++++-
 tests/nvme/049  | 15 +++++++++++----
 3 files changed, 20 insertions(+), 6 deletions(-)

diff --git a/tests/block/003 b/tests/block/003
index 2af9b89ec3e5..b0dd1d1fd62b 100755
--- a/tests/block/003
+++ b/tests/block/003
@@ -18,10 +18,14 @@ device_requires() {
 }
 
 test_device() {
+	local test_dev_bs
+
+	test_dev_bs=$(_min_io "$TEST_DEV")
+
 	echo "Running ${TEST_NAME}"
 
 	FIO_PERF_FIELDS=("trim iops")
-	_fio_perf --bsrange=4k-4g --rw=randtrim --norandommap --name=discards \
+	_fio_perf --bsrange="${test_dev_bs}"-4g --rw=randtrim --norandommap --name=discards \
 		--filename="$TEST_DEV" --number_ios=200k
 
 	echo "Test complete"
diff --git a/tests/block/007 b/tests/block/007
index 3b68d0deec35..8043a83a565b 100755
--- a/tests/block/007
+++ b/tests/block/007
@@ -31,13 +31,16 @@ cleanup_fallback_device() {
 }
 
 run_fio_job() {
+	local test_dev_bs
+
+	test_dev_bs=$(_min_io "$TEST_DEV")
 	if _test_dev_is_rotational; then
 		size="32m"
 	else
 		size="1g"
 	fi
 
-	_fio_perf --bs=4k --rw=randread --norandommap --name=reads \
+	_fio_perf --bs="$test_dev_bs" --rw=randread --norandommap --name=reads \
 		--filename="$TEST_DEV" --size="$size" --direct=1 \
 		--ioengine=pvsync2 --hipri="$1"
 }
diff --git a/tests/nvme/049 b/tests/nvme/049
index 88d4fb122988..7304d6604d8f 100755
--- a/tests/nvme/049
+++ b/tests/nvme/049
@@ -19,10 +19,16 @@ test_device() {
 	echo "Running ${TEST_NAME}"
 
 	local ngdev=${TEST_DEV/nvme/ng}
-	local common_args=(
+	local test_dev_bs
+	local target_size=4096
+	local common_args=()
+	local fio_output
+
+	test_dev_bs=$(_min_io "$ngdev")
+	common_args=(
 		--size=1M
 		--filename="$ngdev"
-		--bs=4k
+		--bs="$test_dev_bs"
 		--rw=randread
 		--numjobs=1
 		--iodepth=16
@@ -32,10 +38,11 @@ test_device() {
 		--time_based
 		--runtime=2
 	)
-	local fio_output
+
+	((test_dev_bs > target_size)) && target_size=$test_dev_bs
 
 	# check security permission
-	if ! fio_output=$(fio --name=check --size=4k --filename="$ngdev" \
+	if ! fio_output=$(fio --name=check --bs="$test_dev_bs" --size="$target_size" --filename="$ngdev" \
 			    --rw=read --ioengine=io_uring_cmd 2>&1) &&
 			grep -q -e "Operation not permitted" \
 				-e "Permission denied" <<< "$fio_output"; then
-- 
2.45.2


  parent reply	other threads:[~2025-02-12 20:54 UTC|newest]

Thread overview: 16+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2025-02-12 20:54 [PATCH blktests v3 0/6] enable bs > ps device testing Luis Chamberlain
2025-02-12 20:54 ` [PATCH blktests v3 1/6] common/xfs: ignore first umount error on _xfs_mkfs_and_mount() Luis Chamberlain
2025-02-12 20:58   ` Bart Van Assche
2025-02-12 21:07     ` Luis Chamberlain
2025-02-14 11:02       ` Shinichiro Kawasaki
2025-02-12 20:54 ` [PATCH blktests v3 2/6] block/032: make error messages clearer if mkfs or mount fails Luis Chamberlain
2025-02-14 11:06   ` Shinichiro Kawasaki
2025-02-12 20:54 ` [PATCH blktests v3 3/6] common: add and use min io for fio Luis Chamberlain
2025-02-14 11:24   ` Shinichiro Kawasaki
2025-02-12 20:54 ` [PATCH blktests v3 4/6] common/xfs: use min io for fs blocksize Luis Chamberlain
2025-02-12 20:54 ` Luis Chamberlain [this message]
2025-02-12 20:54 ` [PATCH blktests v3 6/6] common/xfs: add _test_dev_suits_xfs() to verify logical block size will work Luis Chamberlain
2025-02-14 11:28   ` Shinichiro Kawasaki
2025-02-14 11:34 ` [PATCH blktests v3 0/6] enable bs > ps device testing Shinichiro Kawasaki
2025-02-14 18:54   ` Luis Chamberlain
2025-02-21  9:55     ` Shinichiro Kawasaki

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20250212205448.2107005-6-mcgrof@kernel.org \
    --to=mcgrof@kernel.org \
    --cc=gost.dev@samsung.com \
    --cc=hare@suse.de \
    --cc=linux-block@vger.kernel.org \
    --cc=patches@lists.linux.dev \
    --cc=shinichiro.kawasaki@wdc.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.